Index: /branches/PTSP/HeuristicLab.Problems.Instances/3.3/Types/VRP/VRPData.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.Instances/3.3/Types/VRP/VRPData.cs	(revision 13412)
+++ /branches/PTSP/HeuristicLab.Problems.Instances/3.3/Types/VRP/VRPData.cs	(revision 13412)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describes instances of the Vehicle Routing Problem (VRP).
+  /// </summary>
+  public class VRPData : IVRPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The number of customers and the depot
+    /// </summary>
+    public int Dimension { get; set; }
+    /// <summary>
+    /// The distance measure that is used to calculate the distance between
+    ///the coordinates if no <see cref="Distances"/> is given.
+    /// </summary>
+    public DistanceMeasure DistanceMeasure { get; set; }
+    /// <summary>
+    /// Optional! The maximum number of vehicles that can be used.
+    /// </summary>
+    /// <remarks>
+    /// If no number is given, but a maximum is required, it can be assumed that
+    /// the maximum number of vehicles is equal to the number of customers as
+    /// there cannot be more than one vehicle per customer.
+    /// </remarks>
+    public double? MaximumVehicles { get; set; }
+    /// <remarks>
+    /// Either Distances or the <see cref="Coordinates"/> need to be specified along
+    /// with a distance measure.
+    /// </remarks>
+    public double[,] Distances { get; set; }
+    /// <summary>
+    /// Optional! A a matrix of dimension [N, 2] where each row is either the customer
+    /// or the depot and the columns represent x and y coordinates respectively.
+    /// </summary>
+    /// <remarks>
+    /// Either <see cref="Distances"/> or the Coordinates need to be specified along
+    /// with a distance measure.
+    /// </remarks>
+    public double[,] Coordinates { get; set; }
+    /// <summary>
+    /// The demand vector that specifies how many goods need to be delivered.
+    /// The vector has to include the depot, but with a demand of 0.
+    /// </summary>
+    public double[] Demands { get; set; }
+
+    /// <summary>
+    /// Optional! The best-known solution as a list of tours in path-encoding.
+    /// </summary>
+    public int[][] BestKnownTour { get; set; }
+    /// <summary>
+    /// Optional! Specifies the used vehicle for a given tour.
+    /// </summary>
+    public int[] BestKnownTourVehicleAssignment { get; set; }
+    /// <summary>
+    /// Optional! The quality of the best-known solution.
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+
+    /// <summary>
+    /// If only the coordinates are given, can calculate the distance matrix.
+    /// </summary>
+    /// <returns>A full distance matrix between all cities.</returns>
+    public double[,] GetDistanceMatrix() {
+      return DistanceHelper.GetDistanceMatrix(DistanceMeasure, Coordinates, Distances, Dimension);
+    }
+  }
+}
Index: /branches/PTSP/HeuristicLab.Problems.PTSP.Tests-3.3/PTSPMoveEvaluatorTest.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP.Tests-3.3/PTSPMoveEvaluatorTest.cs	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP.Tests-3.3/PTSPMoveEvaluatorTest.cs	(revision 13412)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -6,7 +27,6 @@
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
-using System.Diagnostics;
 
-namespace HeuristicLab.Problems.PTSP.Tests_3._3 {
+namespace HeuristicLab.Problems.PTSP.Tests {
   /// <summary>
   ///This is a test class for PTSP move evaluators
@@ -15,10 +35,11 @@
   public class PTSPMoveEvaluatorTest {
     private const int ProblemSize = 10;
+    private const int RealizationsSize = 100;
     private static DoubleMatrix coordinates;
     private static DistanceMatrix distances;
     private static Permutation tour;
     private static MersenneTwister random;
-    private static ItemList<ItemList<IntValue>> realizations;
-    private static DoubleArray ProbabilityMatrix;
+    private static ItemList<BoolArray> realizations;
+    private static DoubleArray probabilities;
 
     [ClassInitialize]
@@ -27,10 +48,10 @@
       coordinates = new DoubleMatrix(ProblemSize, 2);
       distances = new DistanceMatrix(ProblemSize, ProblemSize);
-      for (int i = 0; i < ProblemSize; i++) {
+      for (var i = 0; i < ProblemSize; i++) {
         coordinates[i, 0] = random.Next(ProblemSize * 10);
         coordinates[i, 1] = random.Next(ProblemSize * 10);
       }
-      for (int i = 0; i < ProblemSize - 1; i++) {
-        for (int j = i + 1; j < ProblemSize; j++) {
+      for (var i = 0; i < ProblemSize - 1; i++) {
+        for (var j = i + 1; j < ProblemSize; j++) {
           distances[i, j] = Math.Round(Math.Sqrt(Math.Pow(coordinates[i, 0] - coordinates[j, 0], 2) + Math.Pow(coordinates[i, 1] - coordinates[j, 1], 2)));
           distances[j, i] = distances[i, j];
@@ -38,27 +59,20 @@
       }
 
-      ProbabilityMatrix = new DoubleArray(ProblemSize);
-      for (int i = 0; i < ProblemSize; i++) {
-        ProbabilityMatrix[i] = random.NextDouble();
+      probabilities = new DoubleArray(ProblemSize);
+      for (var i = 0; i < ProblemSize; i++) {
+        probabilities[i] = random.NextDouble();
       }
 
-      int numRealizations = 100;
-      int countOnes = 0;
-      realizations = new ItemList<ItemList<IntValue>>(numRealizations);
-      for (int i = 0; i < numRealizations; i++) {
-        ItemList<IntValue> newRealization = new ItemList<IntValue>();
+      realizations = new ItemList<BoolArray>(RealizationsSize);
+      for (var i = 0; i < RealizationsSize; i++) {
+        var countOnes = 0;
+        var newRealization = new BoolArray(ProblemSize);
         while (countOnes < 4) { //only generate realizations with at least 4 cities visited
           countOnes = 0;
-          newRealization.Clear();
-          for (int j = 0; j < ProblemSize; j++) {
-            if (ProbabilityMatrix[j] > random.NextDouble()) {
-              newRealization.Add(new IntValue(1));
-              countOnes++;
-            } else {
-              newRealization.Add(new IntValue(0));
-            }
+          for (var j = 0; j < ProblemSize; j++) {
+            newRealization[j] = random.NextDouble() < probabilities[j];
+            if (newRealization[j]) countOnes++;
           }
         }
-        countOnes = 0;
         realizations.Add(newRealization);
       }
@@ -68,25 +82,19 @@
 
     [TestMethod]
-    [TestCategory("Problems.TravelingSalesman")]
+    [TestCategory("Problems.ProbabilisticTravelingSalesman")]
     [TestProperty("Time", "short")]
     public void InversionMoveEvaluatorTest() {
+      var beforeMatrix = EstimatedProbabilisticTravelingSalesmanProblem.Evaluate(tour, distances, realizations)[0];
 
-      EstimatedProbabilisticTravelingSalesmanProblem ePTSP = new EstimatedProbabilisticTravelingSalesmanProblem();
+      for (var i = 0; i < 500; i++) {
+        var move = StochasticInversionSingleMoveGenerator.Apply(tour, random);
+        var moveMatrix = PTSPEstimatedInversionMoveEvaluator.EvaluateByDistanceMatrix(tour, move, distances, realizations);
+        InversionManipulator.Apply(tour, move.Index1, move.Index2);
+        var afterMatrix = EstimatedProbabilisticTravelingSalesmanProblem.Evaluate(tour, distances, realizations)[0];
 
-      double beforeMatrix = ePTSP.EvaluateWithParams(distances, ProbabilityMatrix, realizations, tour)[0];
-
-      for (int i = 0; i < 500; i++) {
-        var move = StochasticInversionSingleMoveGenerator.Apply(tour, random);
-
-        double moveMatrix = PTSPEstimatedInversionEvaluator.EvaluateByDistanceMatrix(tour, move, distances,realizations);
-
-        string failureString = string.Format(@"Inversion move is calculated with quality {0}, but actual difference is {4}.
-The move would invert the tour {1} between values {2} and {3}.", moveMatrix.ToString(), tour.ToString(), tour[move.Index1].ToString(), tour[move.Index2].ToString(), "{0}");
-
-        InversionManipulator.Apply(tour, move.Index1, move.Index2);
-
-        double afterMatrix = ePTSP.EvaluateWithParams(distances, ProbabilityMatrix, realizations, tour)[0];
-
-        Assert.IsTrue(Math.Abs(moveMatrix).IsAlmost(Math.Abs(afterMatrix - beforeMatrix)), string.Format(failureString, (Math.Abs(afterMatrix - beforeMatrix)).ToString()));
+        Assert.IsTrue(Math.Abs(moveMatrix).IsAlmost(Math.Abs(afterMatrix - beforeMatrix)),
+          string.Format(@"Inversion move is calculated with quality {0}, but actual difference is {4}.
+The move would invert the tour {1} between values {2} and {3}.",
+          moveMatrix, tour, tour[move.Index1], tour[move.Index2], Math.Abs(afterMatrix - beforeMatrix)));
 
         beforeMatrix = afterMatrix;
@@ -95,25 +103,19 @@
 
     [TestMethod]
-    [TestCategory("Problems.TravelingSalesman")]
+    [TestCategory("Problems.ProbabilisticTravelingSalesman")]
     [TestProperty("Time", "short")]
     public void InsertionMoveEvaluatorTest() {
+      var beforeMatrix = EstimatedProbabilisticTravelingSalesmanProblem.Evaluate(tour, distances, realizations)[0];
 
-      EstimatedProbabilisticTravelingSalesmanProblem ePTSP = new EstimatedProbabilisticTravelingSalesmanProblem();
+      for (var i = 0; i < 500; i++) {
+        var move = StochasticTranslocationSingleMoveGenerator.Apply(tour, random);
+        var moveMatrix = PTSPEstimatedInsertionMoveEvaluator.EvaluateByDistanceMatrix(tour, move, distances, realizations);
+        TranslocationManipulator.Apply(tour, move.Index1, move.Index1, move.Index3);
+        var afterMatrix = EstimatedProbabilisticTravelingSalesmanProblem.Evaluate(tour, distances, realizations)[0];
 
-      double beforeMatrix = ePTSP.EvaluateWithParams(distances, ProbabilityMatrix, realizations, tour)[0];
-
-      for (int i = 0; i < 500; i++) {
-        var move = StochasticTranslocationSingleMoveGenerator.Apply(tour, random);
-
-        double moveMatrix = PTSPEstimatedInsertionEvaluator.EvaluateByDistanceMatrix(tour, move, distances, realizations);
-
-        string failureString = string.Format(@"Inversion move is calculated with quality {0}, but actual difference is {4}.
-The move would invert the tour {1} between values {2} and {3}.", moveMatrix.ToString(), tour.ToString(), tour[move.Index1].ToString(), tour[move.Index2].ToString(), "{0}");
-
-        TranslocationManipulator.Apply(tour, move.Index1, move.Index1, move.Index3);
-
-        double afterMatrix = ePTSP.EvaluateWithParams(distances, ProbabilityMatrix, realizations, tour)[0];
-
-        Assert.IsTrue(Math.Abs(moveMatrix).IsAlmost(Math.Abs(afterMatrix - beforeMatrix)), string.Format(failureString, (Math.Abs(afterMatrix - beforeMatrix)).ToString()));
+        Assert.IsTrue(Math.Abs(moveMatrix).IsAlmost(Math.Abs(afterMatrix - beforeMatrix)),
+          string.Format(@"Insertion move is calculated with quality {0}, but actual difference is {4}.
+The move would invert the tour {1} between values {2} and {3}.",
+          moveMatrix, tour, tour[move.Index1], tour[move.Index2], Math.Abs(afterMatrix - beforeMatrix)));
 
         beforeMatrix = afterMatrix;
@@ -122,15 +124,13 @@
 
     [TestMethod]
-    [TestCategory("Problems.TravelingSalesman")]
+    [TestCategory("Problems.ProbabilisticTravelingSalesman")]
     [TestProperty("Time", "short")]
     public void AnalyticalTest() {
-      for (int i = 0; i < 10; i++) {
-        tour = new Permutation(PermutationTypes.RelativeUndirected, ProblemSize, random);
-        EstimatedProbabilisticTravelingSalesmanProblem ePTSP = new EstimatedProbabilisticTravelingSalesmanProblem();
-        double estimated = ePTSP.EvaluateWithParams(distances, ProbabilityMatrix, realizations, tour)[0];
+      for (var i = 0; i < 10; i++) {
+        var perm = new Permutation(PermutationTypes.RelativeUndirected, ProblemSize, random);
+        var estimated = EstimatedProbabilisticTravelingSalesmanProblem.Evaluate(perm, distances, realizations)[0];
 
-        AnalyticalProbabilisticTravelingSalesmanProblem aPTSP = new AnalyticalProbabilisticTravelingSalesmanProblem();
-        double analytical = aPTSP.EvaluateWithParams(distances, ProbabilityMatrix, tour);
-        Console.WriteLine(Math.Abs(analytical-estimated));
+        var analytical = AnalyticalProbabilisticTravelingSalesmanProblem.Evaluate(perm, distances, probabilities);
+        Console.WriteLine(Math.Abs(analytical - estimated));
       }
     }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/HeuristicLab.Problems.PTSP.Views-3.3.csproj
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/HeuristicLab.Problems.PTSP.Views-3.3.csproj	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/HeuristicLab.Problems.PTSP.Views-3.3.csproj	(revision 13412)
@@ -84,4 +84,9 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Random-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
Index: /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs	(revision 13412)
@@ -22,5 +22,4 @@
 using System;
 using System.Drawing;
-using System.Windows.Forms;
 using HeuristicLab.Core.Views;
 using HeuristicLab.Data;
@@ -156,5 +155,4 @@
       }
     }
-
     private void Content_ProbabilitiesChanged(object sender, EventArgs e) {
       if (InvokeRequired)
Index: /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/Plugin.cs.frame
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/Plugin.cs.frame	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/Plugin.cs.frame	(revision 13412)
@@ -1,18 +1,41 @@
-﻿using HeuristicLab.PluginInfrastructure;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
 namespace HeuristicLab.Problems.PTSP.Views {
-    [Plugin("HeuristicLab.Problems.PTSP.Views", "3.3.11.$WCREV$")]
-    [PluginFile("HeuristicLab.Problems.PTSP.Views-3.3.dll", PluginFileType.Assembly)]
-	[PluginDependency("HeuristicLab.Common", "3.3")]
-	[PluginDependency("HeuristicLab.Core", "3.3")]
-	[PluginDependency("HeuristicLab.Core.Views", "3.3")]
-	[PluginDependency("HeuristicLab.Data", "3.3")]
-	[PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
-	[PluginDependency("HeuristicLab.MainForm", "3.3")]
-	[PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-	[PluginDependency("HeuristicLab.Optimization", "3.3")]
-	[PluginDependency("HeuristicLab.Optimization.Views", "3.3")]
-	[PluginDependency("HeuristicLab.Parameters", "3.3")]
-	[PluginDependency("HeuristicLab.Problems.PTSP", "3.3")]
-    public class Plugin : PluginBase {
-    }
+  [Plugin("HeuristicLab.Problems.PTSP.Views", "3.3.13.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.PTSP.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.PTSP", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  public class HeuristicLabProblemsPTSPViewsPlugin : PluginBase {
+  }
 }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/ProbabilisticTravelingSalesmanProblemView.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/ProbabilisticTravelingSalesmanProblemView.cs	(revision 13411)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/ProbabilisticTravelingSalesmanProblemView.cs	(revision 13412)
@@ -21,9 +21,8 @@
 
 using System;
-using System.Windows.Forms;
+using HeuristicLab.Data;
 using HeuristicLab.MainForm;
 using HeuristicLab.Optimization.Views;
-using HeuristicLab.Problems.PTSP;
-using HeuristicLab.Data;
+using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.PTSP.Views {
@@ -40,5 +39,5 @@
 
     /// <summary>
-    /// Initializes a new instance of <see cref="ProbabilisticTravelingSalesmanView"/>.
+    /// Initializes a new instance of <see cref="ProbabilisticTravelingSalesmanProblemView"/>.
     /// </summary>
     public ProbabilisticTravelingSalesmanProblemView() {
@@ -47,16 +46,14 @@
 
     protected override void DeregisterContentEvents() {
-      Content.CoordinatesParameter.ValueChanged -= new EventHandler(CoordinatesParameter_ValueChanged);
-      Content.ProbabilityMatrixParameter.ValueChanged -= new EventHandler(ProbabilityParameter_ValueChanged);
-      //Content.BestKnownQualityParameter.ValueChanged -= new EventHandler(BestKnownQualityParameter_ValueChanged);
-      Content.BestKnownSolutionParameter.ValueChanged -= new EventHandler(BestKnownSolutionParameter_ValueChanged);
+      Content.CoordinatesParameter.ValueChanged -= CoordinatesParameter_ValueChanged;
+      Content.ProbabilitiesParameter.ValueChanged -= ProbabilityParameter_ValueChanged;
+      Content.BestKnownSolutionParameter.ValueChanged -= BestKnownSolutionParameter_ValueChanged;
       base.DeregisterContentEvents();
     }
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.CoordinatesParameter.ValueChanged += new EventHandler(CoordinatesParameter_ValueChanged);
-      Content.ProbabilityMatrixParameter.ValueChanged += new EventHandler(ProbabilityParameter_ValueChanged);
-      //Content.BestKnownQualityParameter.ValueChanged += new EventHandler(BestKnownQualityParameter_ValueChanged);
-      Content.BestKnownSolutionParameter.ValueChanged += new EventHandler(BestKnownSolutionParameter_ValueChanged);
+      Content.CoordinatesParameter.ValueChanged += CoordinatesParameter_ValueChanged;
+      Content.ProbabilitiesParameter.ValueChanged += ProbabilityParameter_ValueChanged;
+      Content.BestKnownSolutionParameter.ValueChanged += BestKnownSolutionParameter_ValueChanged;
     }
     protected override void OnContentChanged() {
@@ -65,5 +62,5 @@
         pathPTSPTourView.Content = null;
       } else {
-        pathPTSPTourView.Content = new PathPTSPTour(Content.Coordinates, Content.ProbabilityMatrix, Content.BestKnownSolution, new DoubleValue(Content.BestKnownQuality));
+        pathPTSPTourView.Content = new PathPTSPTour(Content.Coordinates, Content.Probabilities, Content.BestKnownSolution, new DoubleValue(Content.BestKnownQuality));
       }
     }
@@ -77,13 +74,10 @@
       pathPTSPTourView.Content.Coordinates = Content.Coordinates;
     }
-
     private void ProbabilityParameter_ValueChanged(object sender, EventArgs e) {
-      pathPTSPTourView.Content.Probabilities = Content.ProbabilityMatrix;
-    }
-    private void BestKnownQualityParameter_ValueChanged(object sender, EventArgs e) {
-      pathPTSPTourView.Content.Quality = new DoubleValue(Content.BestKnownQuality);
+      pathPTSPTourView.Content.Probabilities = Content.Probabilities;
     }
     private void BestKnownSolutionParameter_ValueChanged(object sender, EventArgs e) {
       pathPTSPTourView.Content.Permutation = Content.BestKnownSolution;
+      pathPTSPTourView.Content.Quality = new DoubleValue(Content.Evaluate(Content.BestKnownSolution, new MersenneTwister()));
     }
   }
